/// @cond EO_CXX_EO_IMPL

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
inline void elm_interface_atspi_image::extents_get(bool screen_coords_, int* x_, int* y_, int* width_, int* height_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_atspi_image_extents_get(::efl::eolian::to_c(screen_coords_), x_, y_, width_, height_));
}
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
inline ::efl::eina::string_view elm_interface_atspi_image::description_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_image_description_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
inline void elm_interface_atspi_image::description_set(::efl::eina::string_view description_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_atspi_image_description_set(::efl::eolian::to_c(description_)));
}
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
inline ::efl::eina::string_view elm_interface_atspi_image::locale_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_image_locale_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
inline void eo_cxx::elm_interface_atspi_image::extents_get(bool screen_coords_, int* x_, int* y_, int* width_, int* height_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_atspi_image_extents_get(::efl::eolian::to_c(screen_coords_), x_, y_, width_, height_));
}
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
inline ::efl::eina::string_view eo_cxx::elm_interface_atspi_image::description_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_image_description_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
inline void eo_cxx::elm_interface_atspi_image::description_set(::efl::eina::string_view description_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_atspi_image_description_set(::efl::eolian::to_c(description_)));
}
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
inline ::efl::eina::string_view eo_cxx::elm_interface_atspi_image::locale_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_image_locale_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

inline ::eo_cxx::elm_interface_atspi_image::operator ::elm_interface_atspi_image() const
{
   return *static_cast<::elm_interface_atspi_image const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_interface_atspi_image::operator ::elm_interface_atspi_image&()
{
   return *static_cast<::elm_interface_atspi_image*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_interface_atspi_image::operator ::elm_interface_atspi_image const&() const
{
   return *static_cast<::elm_interface_atspi_image const*>(static_cast<void const*>(this));
}

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
template <typename T>
void _elm_interface_atspi_image_extents_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool screen_coords_, int* x_, int* y_, int* width_, int* height_)
{
   try
      {
         static_cast<T*>(self->this_)->extents_get(::efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), x_, y_, width_, height_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
template <typename T>
::efl::eina::string_view _elm_interface_atspi_image_description_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->description_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
template <typename T>
void _elm_interface_atspi_image_description_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * description_)
{
   try
      {
         static_cast<T*>(self->this_)->description_set(::efl::eolian::to_cxx<::efl::eina::string_view>(description_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
template <typename T>
::efl::eina::string_view _elm_interface_atspi_image_locale_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->locale_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_image >
{
   template <typename T>
   struct type
   {
#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
      virtual void extents_get(bool screen_coords_, int* x_, int* y_, int* width_, int* height_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_image_extents_get(::efl::eolian::to_c(screen_coords_), x_, y_, width_, height_));
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
      virtual ::efl::eina::string_view description_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_image_description_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
      virtual void description_set(::efl::eina::string_view description_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_image_description_set(::efl::eolian::to_c(description_)));
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
      virtual ::efl::eina::string_view locale_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_image_locale_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_image >
{
   static constexpr int value = 
#if defined(ELM_INTERFACE_ATSPI_IMAGE_PROTECTED) && defined(ELM_INTERFACE_ATSPI_IMAGE_BETA)
      4
#elif defined(ELM_INTERFACE_ATSPI_IMAGE_PROTECTED)
      4
#elif defined(ELM_INTERFACE_ATSPI_IMAGE_BETA)
      0
#else
      0
#endif
;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_interface_atspi_image>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_image_extents_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_image_extents_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_image_description_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_image_description_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_image_description_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_image_description_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_IMAGE_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_image_locale_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_image_locale_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_image>)
{
   return (ELM_INTERFACE_ATSPI_IMAGE_MIXIN);
}

} } }

/// @endcond

